/* 
 * File:   main.cpp
 * Author: angelarturo
 *
 * Created on July 1, 2013, 1:58 PM
 */

//PROBLEMA.
/*Maximizar y minimizar la función f(x,y) = 21.5 + x*sen(4*pi*x) + 
 * y*sen(20*pi*y) en los siguientes rangos:
 * 
 * x=[-3.0,12.1] & y=[4.1,5.8]
 * 
 * Con una precisión de 4 decimales utilizando el algoritmo genético simple.
 * 
 */

#include <cstdlib>      //Librería de propósito general (stdlib.h).
#include <stdio.h>      //Librería de entradas y salidas de datos I/O.
#include <cmath>        //Librería para operaciones matemáticas (math.h).

using namespace std;

/*
 * 
 */
int main(int argc, char** argv) {

    printf("**************************************\n");
    printf("*******ALGORITMO GENETICO SIMPLE******\n");
    printf("**************************************\n");
    printf("Elabor%c: Arthur91x\n",162);
    printf("Fecha: 1/julio/2013\n\n");
    
    //Declaración de parámetros de la población.
    int T = 0;          //Generación actual.
    #define GEN 2       //Número de generaciones.
    #define ind 5       //Número de inidivudos en la población.
    #define Pc 0.75     //Porcentaje de cruzamiento.
    #define Pm 0.015    //Porcentaje de mutación.
    
    //Se codifican las dos variables del problema (x,y).
    #define xs 12.1     //Valor superior de x.
    #define xl -3.0     //Valor inferior de x.
    #define ys 5.8      //Valor superior de y.
    #define yl 4.1      //Valor inferior de y.

    //Se calcula el tamaño de x.
    double Tx = log2((xs-xl)*pow(10,4));   //Tx = log2((xs-xl)*10^precision)
    printf("Tx = %lf\n",ceil(Tx));                //Se imprime el resultado redondeado
                                           //hacia arriba.
    
    
    //Se calcula el tamaño de y.
    double Ty = log2((ys-yl)*pow(10,4));   //Ty = log2((ys-yl)*10^precision)
    printf("Ty = %lf\n",ceil(Ty));                 //Se imprime el resultado redondeado
                                           //hacia arriba.
    //Se genera la población inicial.
    int Pob[33];        //En esta parte del algoritmo la población es NaN.
    
    //Se genera cada miembro de la población de manera aleatoria.
    
    return 0;
}

